C********************************************************************
C  FILE: SOFTRANS.F77
C********************************************************************

      SUBROUTINE SFTRN

C********************************************************************
C
C  SOFTRANS.F77 IS THE MAIN MODULE FOR IMPLEMENTATION
C  OF THE SOFTRANS PROTOCOL.  IT IS DESIGNED AS A
C  SUBROUTINE SO THAT THE MAIN PROGRAM MAY INITIALIZE
C  ANY PARAMETERS THAT MAY BE PASSED AS A RESULT OF THE
C  START OF EXECUTION OF THE PROGRAM.  THESE PARAMETERS
C  INCLUDE:
C
C    LINEIN: THE ASYNC INPUT LINE NAME
C    LINEOUT: THE ASYNC OUTPUT LINE NAME
C    LOGNAME: THE LOG FILE NAME
C
C********************************************************************

      INTEGER I,C,BACK
      INTEGER RDCNT,COUNT,FUNCN
      LOGICAL EMPTY,FULL,FIRST,EOF
      CHARACTER*60 ESTRG
      CHARACTER*1024 FILBF
      INTEGER RCVRQ,SNDRQ,CATRQ,DATBK,EOTBK,RRBLK,RNRBK

      PARAMETER (RCVRQ = 65, SNDRQ = 66)
      PARAMETER (CATRQ = 67, DATBK = 68)
      PARAMETER (EOTBK = 69, RRBLK = 70, RNRBK = 71)

      INTEGER PRNTR,DISK

      PARAMETER (PRNTR = 1,DISK = 2)

      CHARACTER*60 LININ,LINOT,LOGNM
 
      COMMON /FILES/LININ,LINOT,LOGNM

      INTEGER XMCNT,XMCMP,XCMPC
      LOGICAL XMHIB,XMNIB

      COMMON /XMT1/XMCNT,XMCMP,XCMPC,XMHIB,XMNIB

      INTEGER RCTYP,RCXSQ,RCSEQ

      COMMON /RCV2/RCTYP,RCXSQ,RCSEQ

      INTEGER XSEQ,RSEQ,CRC0,CRC1
      INTEGER DEST,FLTYP,ADDR0,ADDR1
      INTEGER DSKTY,VOLUM,DRIVE,SLOT
      LOGICAL ERROR,DONE,CNNCT
      REAL CHARS,BLKS,ERRS
      CHARACTER*60 ERRTX
      CHARACTER*60 DATFL

      COMMON /CTRL2/XSEQ,RSEQ,CRC0,CRC1,CHARS,BLKS,ERRS
      COMMON /CTRL3/CNNCT,DONE
      COMMON /CTRL4/DSKTY,VOLUM,DRIVE,SLOT,DEST,FLTYP,ADDR0,ADDR1
      COMMON /CTRL5/DATFL
      COMMON /ERROR0/ERROR
      COMMON /ERROR1/ERRTX
C
C  OPEN THE LINE AND SETUP FOR THE RUN
C
      CALL CLRER
      CALL LGOPN
      IF (ERROR) GOTO 6000
10    CALL CLRER
      CALL LNOPN (LININ,LINOT,ERROR,ERRTX)
      IF (ERROR) GOTO 6000
20    CHARS = 0.0
      BLKS = 0.0
      ERRS = 0.0
      CNNCT = .TRUE.
      DONE = .FALSE.
      EOF = .FALSE.
      XSEQ = 0
      RSEQ = 0
      CRC0 = 0
      CRC1 = 0
      ADDR0 = 8
      ADDR1 = 0
      CALL CLRER
C
C  GET THE REQUEST BLOCK
C
30    CALL BFRCV (.TRUE.)
      IF (ERROR) GOTO 5500
      IF (RCTYP-DATBK) 40,20,20
40    ERRS = 0.0
      IF (RCTYP-SNDRQ) 1000,2000,3000
C
C  REMOTE WANTS TO TRANSMIT A FILE
C
C  GET DESTINATION
C
1000  ASSIGN 1010 TO BACK
      GOTO 4000
1010  IF (DEST.EQ.PRNTR) GOTO 1050
C
C  GET DISK TYPE
C
      ASSIGN 1012 TO BACK
      GOTO 4100
C
C  GET ADDRESS
C
1012  ASSIGN 1014 TO BACK
      GOTO 4300
C
C  GET FILE TYPE
C
1014  ASSIGN 1016 TO BACK
      GOTO 4200
C
C  GET VOLUME, DRIVE,SLOT
C
1016  ASSIGN 1020 TO BACK
      GOTO 4400
C
C  GET FILENAME
C
1020  ASSIGN 1050 TO BACK
      GOTO 4500
C
C  LOG THE EVENT
C
1050  CALL LGRCV
      IF (ERROR) GOTO 5900
      CALL FLOPN (DSKTY,VOLUM,DRIVE,SLOT,DATFL,DEST,FLTYP,
     + ADDR0,ADDR1,ERROR,ERRTX)
      IF (ERROR) GOTO 5000
      COUNT = 0
1060  CALL BFRCV (.FALSE.)
      IF (ERROR) GOTO 1100
      IF (DONE) GOTO 1090
1070  CALL STGET (C,EMPTY)
      IF (EMPTY) GOTO 1060
      COUNT = COUNT + 1
      CHARS = CHARS + 1.0
      IF (COUNT.GT.1024) THEN
        CALL FILWR (FILBF,1024,ERROR,ERRTX)
        IF (ERROR) GOTO 5000
        COUNT = 1
        END IF
      FILBF(COUNT:COUNT) = CHAR (C)
      GOTO 1070

1090  IF (COUNT.NE.0) CALL FILWR (FILBF,COUNT,ERROR,ERRTX)
      CALL FLCLS
      CALL LGEND
      IF (CNNCT) GOTO 20
      GOTO 5500
C
C  ERROR IN RECEPTION
C
1100  IF (.NOT. DONE) THEN
        ASSIGN 1110 TO BACK
        GOTO 4900
        END IF
1110  CALL LGERR
      GOTO 1090
C
C  REMOTE WANTS TO RECEIVE FILE
C
2000  FUNCN = 0
C
C  GET THE REMOTE DESTINATION
C
      ASSIGN 2010 TO BACK
      GOTO 4000
C
C  GET THE DISK TYPE
C
2010  ASSIGN 2015 TO BACK
      GOTO 4100
C
C  GET THE VOLUME,DRIVE AND SLOT
C
2015  ASSIGN 2020 TO BACK
      GOTO 4400
C
C  GET THE FILENAME
C
2020  ASSIGN 2030 TO BACK
      GOTO 4500
C
C  LOG THE EVENT
C
2030  CALL FLOPN (DSKTY,VOLUM,DRIVE,SLOT,DATFL,0,FLTYP,
     + ADDR0,ADDR1,ERROR,ERRTX)
      CALL LGXMT
      IF (ERROR) GOTO 5000
      FIRST = .TRUE.
      CALL STPUT (FIRST,DEST,FULL)
      CALL STPUT (FIRST,DSKTY,FULL)
      CALL STPUT (FIRST,ADDR0,FULL)
      CALL STPUT (FIRST,ADDR1,FULL)
      CALL STPUT (FIRST,FLTYP,FULL)
      CALL BFSND (RCVRQ,RRBLK)
      FIRST = .TRUE.
      IF (ERROR) GOTO 5000
2100  IF (FUNCN.EQ.0) THEN
        CALL FILRD (FILBF,RDCNT,EOF,ERROR,ERRTX)
      ELSE
        CALL CATLG (DSKTY,VOLUM,DRIVE,SLOT,DATFL,.FALSE.,FILBF,RDCNT,
     +   EOF,ERROR,ERRTX)
        END IF
      IF (ERROR) GOTO 5000
2110  IF (RDCNT.NE.0) THEN
        DO 2120 I = 1,RDCNT
        C = ICHAR (FILBF(I:I))
        CHARS = CHARS + 1.0
        CALL STPUT (FIRST,C,FULL)
        IF (FULL) THEN
          CALL BFSND (DATBK,RRBLK)
          IF (ERROR) GOTO 5000
          FIRST = .TRUE.
          END IF
2120    CONTINUE
        END IF
      IF (.NOT. EOF) GOTO 2100
      IF (.NOT. FIRST) THEN
        CALL BFSND (DATBK,RRBLK)
        IF (ERROR) GOTO 5000
        END IF
      XSEQ = 0
      XMCNT = 0
      XMCMP = 0
      CALL BFSND (EOTBK,EOTBK)
      CALL FLCLS
      CALL LGEND
      IF (CNNCT) GOTO 20
      GOTO 5500
C
C  CATALOG REQUEST, GET DISK TYPE
C
3000  ASSIGN 3002 TO BACK
      GOTO 4100
C
C  GET VOLUME,DRIVE AND SLOT
C
3002  ASSIGN 3004 TO BACK
      GOTO 4400
C
C  GET FILENAME
C
3004  ASSIGN 3010 TO BACK
      GOTO 4500
3010  CALL LGCAT
      CALL CATLG (DSKTY,VOLUM,DRIVE,SLOT,DATFL,.TRUE.,FILBF,RDCNT,
     + EOF,ERROR,ERRTX)
      IF (ERROR) GOTO 5000
      FUNCN = 1
      FIRST = .TRUE.
      GOTO 2110
C
C  GET DESTINATION TYPE
C
4000  CALL STGET (DEST,EMPTY)
      IF (EMPTY) GOTO 20
      GOTO BACK
C
C  GET DISK TYPE
C
4100  CALL STGET (DSKTY,EMPTY)
      IF (EMPTY) GOTO 20
      GOTO BACK
C
C  GET FILE TYPE
C
4200  CALL STGET (FLTYP,EMPTY)
      IF (EMPTY) GOTO 20
      GOTO BACK
C
C  GET BINARY FILE ADDRESS
C
4300  CALL STGET (ADDR0,EMPTY)
      CALL STGET (ADDR1,EMPTY)
      IF (EMPTY) GOTO 20
      GOTO BACK
C
C  GET VOLUME, DRIVE AND SLOT
C
4400  CALL STGET (VOLUM,EMPTY)
      CALL STGET (DRIVE,EMPTY)
      CALL STGET (SLOT,EMPTY)
      IF (EMPTY) GOTO 20
      GOTO BACK
C
C  GET FILENAME
C
4500  DATFL = 
     + '                                                           '
      DO 4510 I=1,30
      CALL STGET (C,EMPTY)
      IF (EMPTY) GOTO 20
      DATFL (I:I) = CHAR (C)
4510  CONTINUE
      GOTO BACK
C
C  ERROR, SEND REMOTE ABORT
C
4900  FIRST = .TRUE.
      CALL FMTER
      ESTRG(1:60) = ERRTX(1:60)
      DO 4910 I = 1,60
      C = ICHAR (ERRTX(I:I))
      IF (C.LT.32) GOTO 4910
      CALL STPUT (FIRST,C,FULL)
4910  CONTINUE
      XSEQ = 1
      CALL BFSND (EOTBK,EOTBK)
      ERRTX(1:60) = ERRTX(1:60)
      GOTO BACK
C
C  ERROR WHILE CONNECTED
C
5000  CALL FLCLS
      CALL LGERR
      CALL LGEND
      IF (.NOT. CNNCT) GOTO 5500
      IF (DONE) GOTO 20
      ASSIGN 20 TO BACK
      GOTO 4900
 
5500  ERRTX = 'LINE CLOSED'
      CALL LGERR
      CALL LNCLS
      GOTO 10
C
C  UNRECOVERABLE ERROR
C
5900  CALL LNCLS
6000  CALL LGERR
      CALL LGCLS
      RETURN
      END

C********************************************************************
C  END OF SOFTRANS.F77
C********************************************************************
