C********************************************************************
C  SOURCE MODULE: STBUFFER.F77
C********************************************************************
      SUBROUTINE BFSND (TYPE,REPLY)

C********************************************************************
C
C  SEND A BUFFER AND WAIT FOR A REPLY
C
C  TYPE:  INTEGER, THE BUFFER TYPE
C  REPLY:  INTEGER, THE ACCEPTABLE REPLY TYPE
C
C********************************************************************

      INTEGER TYPE,REPLY,C,I
      LOGICAL WACK,MONTR,EMPTY
      CHARACTER*10 BUFFR
      INTEGER RCVRQ,SNDRQ,CATRQ,DATBK,EOTBK,RRBLK,RNRBK

      PARAMETER (RCVRQ = 65, SNDRQ = 66)
      PARAMETER (CATRQ = 67, DATBK = 68)
      PARAMETER (EOTBK = 69, RRBLK = 70, RNRBK = 71)

      INTEGER PRNTR,DISK

      PARAMETER (PRNTR = 1,DISK = 2)

      INTEGER RCTYP,RCXSQ,RCSEQ

      COMMON /RCV2/RCTYP,RCXSQ,RCSEQ

      INTEGER RTRYS,TIMOT
      INTEGER CRTRY,CTMOT
      INTEGER XSEQ,RSEQ,CRC0,CRC1
      INTEGER DEST,FLTYP,ADDR0,ADDR1
      INTEGER DSKTY,VOLUM,DRIVE,SLOT
      LOGICAL ERROR,DONE,CNNCT
      REAL CHARS,BLKS,ERRS
      CHARACTER*60 ERRTX

      COMMON /CTRL0/RTRYS,TIMOT
      COMMON /CTRL1/CRTRY,CTMOT
      COMMON /CTRL2/XSEQ,RSEQ,CRC0,CRC1,CHARS,BLKS,ERRS
      COMMON /CTRL3/CNNCT,DONE
      COMMON /CTRL4/DSKTY,VOLUM,DRIVE,SLOT,DEST,FLTYP,ADDR0,ADDR1
      COMMON /ERROR0/ERROR
      COMMON /ERROR1/ERRTX
C
C  SETUP FOR TRANSMIT
C
      CRTRY = RTRYS
      BLKS = BLKS + 1.0
C
C  SEND THE BUFFER
C
10    CALL STXMT (TYPE,XSEQ)
      IF (ERROR) GOTO 5000
      CTMOT = TIMOT
      WACK = .FALSE.
C
C  GET REPLY
C
20    CALL STRCV
      IF (ERROR) GOTO 300
      IF (RCTYP.NE.EOTBK) GOTO 30
      IF (RCTYP.EQ.REPLY) RETURN
      GOTO 6000
C
C  CHECK FOR WAIT ACKNOWLEDGE
C
30    IF (RCTYP.NE.RNRBK) GOTO 100
      WACK = .TRUE.
      CRTRY = 10
40    IF (DEST.EQ.PRNTR) THEN
        CTMOT = 255
      ELSE
        CTMOT = 12
        END IF
      GOTO 20
C
C  CHECK SEQUENCE NUMBER
C
100   WACK = .FALSE.
      IF (MOD(XSEQ+1,8).EQ.RCXSQ) GOTO 200
      ERRS = ERRS + 1.0
      CRTRY = CRTRY - 1
      IF (CRTRY) 5000,5000,10
C
C  CHECK IF APPROPRIATE REPLY
C
200   IF (RCTYP.NE.REPLY) GOTO 300
      XSEQ = MOD (XSEQ+1,8)
      IF (RCTYP.GE.EOTBK) GOTO 210
      IF (RSEQ.NE.RCSEQ) GOTO 5000
      RSEQ = MOD (RSEQ+1,8)
210   RETURN
C
C  ERROR ON RECEPTION
C
300   ERRS = ERRS + 1.0
      IF (.NOT. CNNCT) GOTO 5000
      CRTRY = CRTRY - 1
      IF (CRTRY) 5000,5000,310
310   IF (WACK) GOTO 40
      GOTO 10
      ENTRY BFRCV (MONTR)
C********************************************************************
C
C  RECEIVE A BUFFER
C
C  MONTR: LOGICAL, .TRUE. IF CALL FROM MONITOR IDLE
C
C********************************************************************

      BUFFR(1:1) = CHAR (13)
      BUFFR(2:2) = CHAR (10)
      BUFFR(3:8) = 'READY'
      CRTRY = RTRYS
1010  IF (MONTR) CALL LNXMT (BUFFR,8,ERROR,CNNCT)
      IF (.NOT. MONTR) CALL STXCT (RRBLK,8)
      IF (ERROR) GOTO 5000
      CTMOT = TIMOT
1020  CALL STRCV
      IF (ERROR) GOTO 1050
      BLKS = BLKS + 1.0
      IF (RCTYP-EOTBK) 1030,1100,1050

1030  IF (RCTYP-DATBK) 1040,1200,1050

1040  IF (MONTR) GOTO 1210
1050  ERRS = ERRS + 1.0
      IF (.NOT. CNNCT) GOTO 5000
      CRTRY = CRTRY - 1
      IF (CRTRY) 5000,5000,1010
C
C  EOT RECEIVED
C
1100  IF (MONTR) GOTO 1020
      IF (RCSEQ.NE.0) GOTO 6000
      CALL STXCT (EOTBK,0)
      DONE = .TRUE.
      RETURN
C
C  DATA BLOCK RECEIVED
C
1200  IF (MONTR) GOTO 1050
      IF (RCSEQ.NE.RSEQ) GOTO 1050
1210  RSEQ = MOD (RSEQ+1,8)
      RETURN
C
C  LINE FAILURE
C
5000  ERROR = .TRUE.
      ERRTX = 'LINE FAILURE'
      RETURN
C
C  REMOTE ABORT
C
6000  ERRTX = 'REMOTE ABORT: '
      DO 6010 I = 14,60
      CALL STGET (C,EMPTY)
      IF (EMPTY) GOTO 6020
      ERRTX (I:I) = CHAR (C)
6010  CONTINUE
6020  CALL STXCT (EOTBK,0)
      ERROR = .TRUE.
      DONE = .TRUE.
      RETURN
      END
C********************************************************************
C  END OF STBUFFER.F77
C********************************************************************
