
C********************************************************************
C  MODULE NAME: STSYS.F77
C********************************************************************
      SUBROUTINE FLOPN (DSKTY,VOLUM,DRIVE,SLOT,DATFL,MODE,
     +  FLTYP,ADDR0,ADDR1,ERROR,ERRTX)
C********************************************************************
C
C  OPEN A FILE FOR INPUT OR OUTPUT
C
C  DSKTY  AN INTEGER DESCRIBING THE MICRO DISK TYPE
C            0 = APPLE DOS
C            1 = APPLE PASCAL
C            2 = APPLE CPM
C  VOLUM,DRIVE,SLOT  THESE PARAMETERS ARE IGNORED
C  DATFL  A CHARACTER*60 ARRAY WITH THE FILENAME
C  MODE   0 = READ
C         1 = WRITE TO PRINT
C         2 = WRITE TO DISK
C  FLTYP  AN INTEGER SPECIFIC TO THE MICRO DISK TYPE
C         DESCRIBING THE FILE TYPE
C  ADDR0,ADDR1  BINARY FILE ADDRESS FOR USE WITH APPLE DOS FILES
C  ERROR  LOGICAL, RETURNED .TRUE. IF ERROR ENCOUNTERED
C  ERRTX  A CHARACTER*60 STRING CONTAINING THE ERROR TEXT
C         IF ERROR IS RETURNED .TRUE.
C
C********************************************************************

      INTEGER IOS,SAVMD
      CHARACTER*60 HDRFL
      CHARACTER*256 LCLBF

      COMMON /SYSLC/SAVMD

      INTEGER DSKTY,VOLUM,DRIVE,SLOT,MODE,FLTYP,ADDR0,ADDR1
      LOGICAL ERROR
      CHARACTER*60 DATFL,ERRTX

      INTEGER RDCNT
      LOGICAL EOF
      CHARACTER*1024 FILBF

      INTEGER WRCNT

      LOGICAL FIRST

      CHARACTER*60 LININ,LINOT
      CHARACTER*256 BUFFR
      INTEGER COUNT
      LOGICAL CNNCT

      INTEGER TIMOT
C
C  MAKE THE HEADER FILENAME
C
      DO 5 I = 59,1,-1
      IF (DATFL(I:I).NE.' ') GOTO 6
5     CONTINUE
      I = 1
6     I = I + 1
      DATFL(I:I) = CHAR (0)
      ERROR = .FALSE.
      IF (MODE.EQ.1) DATFL(1:5) = '@LPT<0>'
      HDRFL(1:1) = '$'
      HDRFL(2:60) = DATFL(1:59)
C
C  OPEN THE DATA FILE
C
      VOLUM = 0
      DRIVE = 1
      SLOT = 6
      CALL FOPEN (DATFL,MODE,IOS)
      IF (IOS.NE.0) GOTO 900
      IF (MODE.NE.0) GOTO 500
      OPEN (UNIT=2,FILE=HDRFL,ERR=100,FORM='FORMATTED',STATUS='OLD')
      READ (UNIT=2,FMT=800,ERR=100) DSKTY,FLTYP,ADDR0,ADDR1
      CLOSE (UNIT=2,ERR=10)
10    RETURN
C
C  ERROR ON HEADER FILE OPEN
C
100   DSKTY = 99
      FLTYP = 0
      ADDR0 = 8
      ADDR1 = 0
      RETURN
C
C  FILE OPENED FOR WRITING, WRITE HEADER UNLESS PRINT
C
500   IF (MODE.EQ.1) GOTO 600
      OPEN (UNIT=2,FILE=HDRFL,ERR=900,FORM='FORMATTED',IOSTAT=IOS,
     + STATUS='FRESH')
      WRITE (UNIT=2,FMT=800,ERR=900) DSKTY,FLTYP,ADDR0,ADDR1
      SAVMD = 1
      IF (DSKTY.EQ.0.AND.FLTYP.EQ.0) SAVMD = 0
      CLOSE (UNIT=2,ERR=10)
600   RETURN
800   FORMAT (I4,I4,I4,I4)
C
C  ERROR ON OPEN
C
900   ERROR = .TRUE.
      WRITE (UNIT=ERRTX,FMT=910) IOS
910   FORMAT ('FILE OPEN ERROR = ',I6)
      RETURN
      ENTRY FLCLS

C********************************************************************
C
C  CLOSE THE CURRENT DATA FILE
C
C********************************************************************

      CALL FCLOS
      RETURN
      ENTRY FILRD (FILBF,RDCNT,EOF,ERROR,ERRTX)

C********************************************************************
C
C  READ DATA FROM THE OPEN FILE
C
C  FILBF  A CHARACTER*1024 ARRAY TO RECEIVE THE DATA
C  RDCNT  INTEGER, THE ACTUAL COUNT READ
C  EOF    LOGICAL, RETURNED .TRUE. IF END OF FILE
C  ERROR  LOGICAL, RETURNED .TRUE. IF ERROR ENCOUNTERED
C  ERRTX  A CHARACTER*60 STRING RETURNING ERROR TEXT FOR THE ERROR
C
C********************************************************************

      EOF = .FALSE.
      ERROR = .FALSE.
      CALL FREAD (FILBF,RDCNT,IOS,IEOF)
      IF (IEOF.NE.0) GOTO 2000
      IF (IOS.NE.0) GOTO 2100
      RETURN
C
C  END OF FILE
C
2000  EOF = .TRUE.
      RETURN
C
C  ERROR ON READ
C
2100  ERROR = .TRUE.
      WRITE (UNIT=ERRTX,FMT=2110) IOS
2110  FORMAT ('FILE READ ERROR = ',I6)
      RETURN
      ENTRY FILWR (FILBF,WRCNT,ERROR,ERRTX)

C********************************************************************
C
C  WRITE DATA TO THE OUTPUT FILE
C
C  FILBF  A CHARACTER*1024 ARRAY WITH THE DATA TO WRITE
C  WRCNT  INTEGER, THE NUMBER OF CHARACTERS TO WRITE
C  ERROR  LOGICAL, RETURNED .TRUE. IF AN ERROR OCCURS
C  ERRTX  A CHARACTER*60 ARRAY WITH ERROR TEXT IF ERROR
C           RETURNED .TRUE.
C
C********************************************************************

      IF (SAVMD.EQ.0) THEN
        DO 3000 I = 1,WRCNT
        FILBF(I:I) = CHAR (IAND (ICHAR (FILBF(I:I)),127))
3000    CONTINUE
        END IF
      ERROR = .FALSE.
      CALL FWRIT (FILBF,WRCNT,IOS)
      IF (IOS.NE.0) GOTO 3100
      RETURN
C
C  ERROR ON WRITE
C
3100  ERROR = .TRUE.
      WRITE (UNIT=ERRTX,FMT=3110) IOS
3110  FORMAT ('FILE WRITE ERROR = ',I6)
      RETURN
      ENTRY CATLG (DSKTY,VOLUM,DRIVE,SLOT,DATFL,FIRST,FILBF,RDCNT,
     +             EOF,ERROR,ERRTX)

C********************************************************************
C
C  PERFORM A DIRECTORY LISTING
C
C  DSKTY  INTEGER, THE TYPE OF MICRO DISK FOR THE CATALOG
C  VOLUM,DRIVE,SLOT INTEGERS, ARE IGNORED
C  DATFL  CHARACTER*60 ARRAY WITH FILENAME TEMPLATE
C  FIRST  LOGICAL, .TRUE. IF THIS IS THE FIRST CALL
C  FILBF  A CHARACTER*1024 ARRAY FOR THE READ DATA
C  RDCNT  THE AMOUNT OF DATA PUT INTO FILBF
C  EOF    LOGICAL, RETURNED .TRUE. IF END OF LISTING
C  ERROR  LOGICAL, RETURNED .TRUE. IF ERROR OCCURS
C  ERRTX  A CHARACTER*60 ARRAY WHICH CONTAINS THE ERROR TEXT
C           IF AN ERROR OCCURS
C
C********************************************************************

      WRITE (UNIT=ERRTX,FMT=3610)
3610  FORMAT ('UNIMPLEMENTED FUNCTION')
      ERROR = .TRUE.
      RETURN
      ENTRY LNOPN (LININ,LINOT,ERROR,ERRTX)

C********************************************************************
C
C  OPEN THE COMMUNICATIONS LINE
C
C  LININ  A CHARACTER*60 ARRAY WITH THE INPUT FILENAME
C           FOR THE COMMUNICATIONS LINE
C  LINOT  A CHARACTER*60 ARRAY WITH THE OUTPUT FILENAME
C           FOR THE COMMUNICATIONS LINE
C  ERROR  LOGICAL, RETURNED .TRUE. IF AN ERROR OCCURS
C  ERRTX  A CHARACTER*60 ARRAY WITH THE ERROR TEXT IF ERROR
C           IS RETURNED .TRUE.
C
C********************************************************************

      ERROR = .FALSE.
      CALL COPEN (LININ,IOS)
      IF (IOS.NE.0) GOTO 4100
      OPEN (UNIT=1,ERR=4100,IOSTAT=IOS,FORM='UNFORMATTED',FILE=LINOT)
      RETURN
C
C  ERROR ON OPEN
C
4100  ERROR = .TRUE.
      WRITE (UNIT=ERRTX,FMT=4110) IOS
4110  FORMAT ('LINE OPEN ERROR = ',I6)
      RETURN
      ENTRY LNCLS

C********************************************************************
C
C  CLOSE THE COMMUNICATIONS LINES
C
C********************************************************************

      CALL CCLOS
      CLOSE (UNIT=1)
      RETURN
      ENTRY LNXMT (BUFFR,COUNT,ERROR,CNNCT)

C********************************************************************
C
C  TRANSMIT A BLOCK OF DATA
C
C  BUFFR  A CHARACTER*256 ARRAY WITH THE DATA
C  COUNT  INTEGER, THE NUMBER OF CHARACTERS TO TRANSMIT
C  ERROR  LOGICAL, RETURNED .TRUE. IF AN ERROR OCCURS
C  CNNCT  LOGICAL, RETURNED .FALSE. IF LINE DROPPED
C
C********************************************************************

      ERROR = .FALSE.
      CNNCT = .TRUE.
      WRITE (UNIT=1,ERR=5100) BUFFR(1:COUNT)
      RETURN
C
C  ERROR ON WRITE
C
5100  ERROR = .TRUE.
      CNNCT = .FALSE.
      RETURN
      ENTRY LNRCV (BUFFR,COUNT,TIMOT,ERROR,CNNCT)

C********************************************************************
C
C  RECEIVE A BLOCK FROM THE COMMUNICATIONS LINE
C
C  BUFFR  A CHARACTER*256 ARRAY TO RECEIVE THE DATA
C  COUNT  INTEGER, THE COUNT ACTUALLY READ
C  TIMOT  INTEGER, NOT USED
C  ERROR  LOGICAL, RETURNED .TRUE. IF AN ERROR OCCURS
C  CNNCT  RETURNED .FALSE. IF LINE IS DROPPED
C
C THIS ROUTINE SCANS EACH INPUT LINE FOR A LEFT BRACE ('{')
C TO INDICATE THE START OF THE DATA. THE LEFT BRACE IS STRIPPED
C AND THE REMAINING DATA, EXCLUDING THE CARRIAGE RETURN,
C IS PASSED BACK IN BUFFR.
C
C********************************************************************

      ERROR = .FALSE.
      CNNCT = .TRUE.
      CALL CREAD (LCLBF,J,IOS)
      IF (IOS.NE.0) GOTO 6100
      IF (LCLBF(1:1).EQ.'Q') GOTO 6050
      J = J - 1
      DO 6010 I = 1,J 
      IF (ICHAR (LCLBF(I:I)).EQ.123) GOTO 6020
6010  CONTINUE
      ERROR = .TRUE.
      RETURN
C
C  START OF MESSAGE FOUND
C
6020  COUNT = J - I
      BUFFR(1:COUNT) = LCLBF ((I+1):J)
      RETURN
C
C  PROGRAM TERMINATION REQUESTED
C
6050  STOP 'SOFTRANS TERMINATION'
C
C  ERROR ON READ
C
6100  ERROR = .TRUE.
      RETURN
      END
C********************************************************************
C  END OF STSYS.F77
C********************************************************************

