C********************************************************************
C  SOURCE MODULE:  STUTIL.F77
C********************************************************************
      SUBROUTINE STPUT (FIRST,C,FULL)

C********************************************************************
C
C
C  PUTS A CHARACTER IN THE SOFTRANS TRANSMIT BUFFER
C  WITH ENCODING
C
C  FIRST:  LOGICAL, .TRUE. ON FIRST CALL FOR NEW BUFFER
C  C:  INTEGER, THE BYTE TO PUT
C  FULL:  LOGICAL, RETURNS .TRUE. WHEN BUFFER FULL
C
C********************************************************************

      INTEGER C,PC,CRET
      INTEGER NEXT,BACK,I,INDEX,MSK
      LOGICAL FIRST,FULL,EMPTY

      INTEGER SOM,EOM

      PARAMETER (SOM = 123, EOM = 13)

      INTEGER TOGHI,CMPRS,TOGNB,B1OFF,CMPOF,B2OFF

      PARAMETER (TOGHI = 126, CMPRS = 125)
      PARAMETER (TOGNB = 124, B1OFF = 65)
      PARAMETER (CMPOF = 61, B2OFF = 97)

      INTEGER NSPEC,SPECL(128)

      COMMON /SPEC/NSPEC,SPECL

      INTEGER MSKHI(256),MSKLO(256)

      COMMON /CRCVL/MSKHI,MSKLO

      INTEGER XMCNT,XMCMP,XCMPC
      LOGICAL XMHIB,XMNIB
      CHARACTER*128 XMTBF

      COMMON /XMT0/XMTBF
      COMMON /XMT1/XMCNT,XMCMP,XCMPC,XMHIB,XMNIB

      INTEGER RCCNT,RCCMP,RCMPC,RCIDX
      INTEGER RCTYP,RCXSQ,RCSEQ
      LOGICAL RCHIB,RCNIB
      CHARACTER*128 RCVBF

      COMMON /RCV0/RCVBF
      COMMON /RCV1/RCCNT,RCCMP,RCMPC,RCHIB,RCNIB,RCIDX
      COMMON /RCV2/RCTYP,RCXSQ,RCVSQ

      INTEGER XSEQ,RSEQ,CRC0,CRC1
      LOGICAL ERROR
      REAL CHARS,BLKS,ERRS
      CHARACTER*60 ERRTX
      CHARACTER*60 DATFL

      COMMON /CTRL2/XSEQ,RSEQ,CRC0,CRC1,CHARS,BLKS,ERRS
      COMMON /CTRL5/DATFL
      COMMON /ERROR0/ERROR
      COMMON /ERROR1/ERRTX
C
C  CHECK FOR NEW BUFFER
C
      IF (FIRST) THEN
        XMCNT = 0
        XMCMP = 0
        XCMPC = 256
        XMNIB = .FALSE.
        XMHIB = .FALSE.
        FIRST = .FALSE.
        END IF
C
C  CHECK IF HI BIT SET
C
      PC = 0
      IF (C.GT.127) THEN
        C = C-128
        IF (.NOT.XMHIB) THEN
          XMHIB = .TRUE.
          PC = TOGHI
          END IF
      ELSE
        IF (XMHIB) THEN
          XMHIB = .FALSE.
          PC = TOGHI
          END IF
        END IF
      IF (PC.NE.0) THEN
        ASSIGN 10 TO NEXT
        GOTO 300
10      CONTINUE
        END IF
C
C  CHECK FOR SPECIAL CHARACTERS
C
      IF (NSPEC.NE.0) THEN
        DO 20 I=1,NSPEC
        IF (C.EQ.SPECL(I)) GOTO 100
20      CONTINUE
        END IF
C
C  CHECK FOR CONTROL CHARACTER
C
      IF (C.LT.32.OR.C.GE.SOM) GOTO 100
C
C  NO SPECIAL ENCODING REQUIRED FOR CHARACTER
C
      IF (XMNIB) THEN
        XMNIB = .FALSE.
        PC = TOGNB
        ASSIGN 30 TO NEXT
        GOTO 300
30      CONTINUE
        END IF
      PC = C
      GOTO 200
C
C  CHARACTER NEEDS ENCODING
C
100   IF (.NOT.XMNIB) THEN
        XMNIB = .TRUE.
        ASSIGN 110 TO NEXT
        PC = TOGNB
        GOTO 300
110     CONTINUE
        END IF
      IF (C.LT.32) THEN
        PC = C + B1OFF
      ELSE  
        PC = C / 16 + B2OFF
        ASSIGN 120 TO NEXT
        GOTO 300
120     PC = MOD (C,16) + B2OFF
        END IF
C
C  PUT FINAL BYTE IN, CHECK FOR BUFFER FULL
C
200   ASSIGN 210 TO NEXT
      GOTO 300
210   FULL = .FALSE.
      IF (XMCNT.GE.115) THEN
        FULL = .TRUE.
        ASSIGN 220 TO BACK
        GOTO 400
220     CONTINUE
        END IF
      RETURN
C
C  PUT A BYTE IN THE BUFFER, CHECK COMPRESSION
C
300   IF (PC.EQ.XCMPC) THEN
        XMCMP = XMCMP+1
        ASSIGN 310 TO BACK
        IF (XMCMP.GE.29) GOTO 400
310     GOTO NEXT
        END IF
C
C  CHARACTER NOT THE SAME AS LAST
C
      ASSIGN 320 TO BACK
      GOTO 400
320   XCMPC = PC
      XMCMP = 1
      GOTO NEXT
C
C  TERMINATE COMPRESSION MODE
C
400   IF (XMCMP.EQ.0) GOTO BACK
      IF (XMCMP.LT.4) THEN
        DO 410 I=1,XMCMP
        XMCNT = XMCNT+1
        XMTBF (XMCNT:XMCNT) = CHAR (XCMPC)
410     CONTINUE
      ELSE
        XMCNT = XMCNT + 1
        XMTBF (XMCNT:XMCNT) = CHAR (CMPRS)
        XMCNT = XMCNT + 1
        XMTBF (XMCNT:XMCNT) = CHAR (XCMPC)
        XMCNT = XMCNT + 1
        XMTBF (XMCNT:XMCNT) = CHAR (XMCMP + CMPOF)
        END IF

      XMCMP = 0
      XCMPC = 256
      GOTO BACK
      ENTRY TRMBF

C********************************************************************
C
C  TERMINATE THE BUFFER BY FLUSHING ANY COMPRESSION CHARACTER(S)
C
C********************************************************************

      ASSIGN 500 TO BACK
      GOTO 400
500   RETURN
      ENTRY STGET (CRET,EMPTY)

C********************************************************************
C
C  GET A CHARACTER FROM THE RECEIVE BUFFER
C
C  CRET: INTEGER, THE CHARACTER RETURNED
C  EMPTY: LOGICAL, RETURNS .TRUE. WHEN NO MORE BYTES
C
C********************************************************************

C
C  GET NEXT BYTE FROM BUFFER
C
      EMPTY = .FALSE.
1000  ASSIGN 1010 TO NEXT
      GOTO 1100
1010  IF (PC.NE.TOGHI) GOTO 1020
      RCHIB = .NOT. RCHIB
      GOTO 1000

1020  IF (PC.NE.TOGNB) GOTO 1030
      RCNIB = .NOT. RCNIB
      GOTO 1000

1030  IF (PC.NE.CMPRS) GOTO 1060
      ASSIGN 1040 TO NEXT
      GOTO 1110
1040  RCMPC = PC
      ASSIGN 1050 TO NEXT
      GOTO 1110
1050  RCCMP = PC - CMPOF
      GOTO 1000

1060  IF (RCNIB) THEN
        IF (PC.LT.B2OFF) THEN
          PC = PC - B1OFF
        ELSE
          CRET = (PC - B2OFF) * 16
          ASSIGN 1070 TO NEXT
          GOTO 1100
1070      PC = (PC - B2OFF) + CRET
          END IF
      END IF
      IF (RCHIB) PC = PC + 128
      CRET = PC
      RETURN
C
C  GET NEXT RAW BYTE FROM BUFFER
C
1100  IF (RCCMP.EQ.0) GOTO 1110
      PC = RCMPC
      RCCMP = RCCMP - 1
      GOTO NEXT

1110  PC = ICHAR (RCVBF(RCIDX:RCIDX))
      RCIDX = RCIDX + 1
      IF (RCIDX.LE.(RCCNT+1)) GOTO NEXT
      EMPTY = .TRUE.
      RETURN
      ENTRY CALCC (C)

C********************************************************************
C
C  ADD A CHARACTER INTO THE CRC
C
C  C:  INTEGER, THE NEW CHARATER TO ADD IN
C
C********************************************************************

      INDEX = CRC1 + 1
      MSK = MSKLO (INDEX)
      CRC1 = IXOR (CRC0,MSK)
      MSK = MSKHI (INDEX)
      CRC0 = IXOR (C,MSK)
      RETURN
      ENTRY CLRER

C********************************************************************
C
C  CLEARS ERROR FLAGS
C
C********************************************************************

      ERROR = .FALSE.
      ERRTX = 
     + '                                                            '
      RETURN
      ENTRY FMTER

C********************************************************************
C
C  FORMATS THE ERROR STRING
C
C********************************************************************

      DO 2000 I = 1,60
      IF (ICHAR (ERRTX(I:I)).GT.127) THEN
        PC = ICHAR (ERRTX(I:I)) - 128
        ERRTX(I:I) = CHAR (PC)
        END IF
      IF (ICHAR (ERRTX(I:I)).LT.32) ERRTX (I:I) = ' '

2000  CONTINUE
      RETURN
      END
C********************************************************************
C  END OF STUTIL.F77
C********************************************************************

