C********************************************************************
C  SOURCE MODULE:  STXMTRCV.F77
C********************************************************************

      SUBROUTINE STXCT(BFTYP,XMSEQ)
C********************************************************************
C
C  TRANSMIT A CONTROL BLOCK
C
C  BFTYP: INTEGER, THE CONTROL TYPE FOR THE BUFFER
C  XMSEQ:  INTEGER, THE TRANSMIT SEQUENCE NUMBER
C
C********************************************************************

      INTEGER BFTYP,XMSEQ
      INTEGER CRC0H,CRC0L,CRC1H,CRC1L,COUNT,I
      LOGICAL FIRST
      CHARACTER*256 BUFFR

      INTEGER SOM,EOM

      PARAMETER (SOM = 123, EOM = 13)

      INTEGER TOGHI,CMPRS,TOGNB,B1OFF,CMPOF,B2OFF

      PARAMETER (TOGHI = 126, CMPRS = 125)
      PARAMETER (TOGNB = 124, B1OFF = 65)
      PARAMETER (CMPOF = 61, B2OFF = 97)

      INTEGER XMCNT,XMCMP,XCMPC
      LOGICAL XMHIB,XMNIB
      CHARACTER*128 XMTBF

      COMMON /XMT0/XMTBF
      COMMON /XMT1/XMCNT,XMCMP,XCMPC,XMHIB,XMNIB

      INTEGER RCCNT,RCCMP,RCMPC,RCIDX
      INTEGER RCTYP,RCXSQ,RCSEQ
      LOGICAL RCHIB,RCNIB
      CHARACTER*128 RCVBF

      COMMON /RCV0/RCVBF
      COMMON /RCV1/RCCNT,RCCMP,RCMPC,RCHIB,RCNIB,RCIDX
      COMMON /RCV2/RCTYP,RCXSQ,RCSEQ

      INTEGER RTRYS,TIMOT
      INTEGER CRTRY,CTMOT
      INTEGER XSEQ,RSEQ,CRC0,CRC1
      INTEGER DEST,FLTYP,ADDR0,ADDR1
      INTEGER DSKTY,VOLUM,DRIVE,SLOT
      LOGICAL ERROR,DONE,CNNCT
      REAL CHARS,BLKS,ERRS
      CHARACTER*60 ERRTX

      COMMON /CTRL0/RTRYS,TIMOT
      COMMON /CTRL1/CRTRY,CTMOT
      COMMON /CTRL2/XSEQ,RSEQ,CRC0,CRC1,CHARS,BLKS,ERRS
      COMMON /CTRL3/CNNCT,DONE
      COMMON /CTRL4/DSKTY,VOLUM,DRIVE,SLOT,DEST,FLTYP,ADDR0,ADDR1
      COMMON /ERROR0/ERROR
      COMMON /ERROR1/ERRTX

      LOGICAL BUGFG

      COMMON /BUG/BUGFG
C
C  CLEAR BUFFER
C
      XMCNT = 0
      XMCMP = 0
      GOTO 10
      ENTRY STXMT(BFTYP,XMSEQ)

C********************************************************************
C
C  SENDS A PREPARED BUFFER
C
C  BFTYP: INTEGER, THE BUFFER TYPE BYTE
C  XMSEQ: INTEGER, THE TRANSMIT SEQUENCE NUMBER
C
C********************************************************************

C
C  ADD THE HEADER
C
10    BUFFR(1:1) = CHAR(SOM)
      BUFFR(2:2) = CHAR(BFTYP)
      BUFFR(3:3) = CHAR(RSEQ+48)
      BUFFR(4:4) = CHAR(XMSEQ+48)
C
C  ADD DATA IF ANY
C
      CALL TRMBF
      IF (XMCNT.NE.0) BUFFR(5:XMCNT+4) = XMTBF(1:XMCNT)
      COUNT = XMCNT+4
C
C  COMPUTE THE CRC FOR THE BLOCK
C
      CRC0 = 0
      CRC1 = 0      
      DO 20 I = 2,COUNT
      CALL CALCC(ICHAR(BUFFR(I:I)))
20    CONTINUE
C
C  ENCODE THE CRC
C
      COUNT = COUNT+1
      I = (CRC1 / 16) + B2OFF
      BUFFR(COUNT:COUNT) = CHAR(I)
      COUNT = COUNT+1
      I = MOD(CRC1,16) + B2OFF
      BUFFR(COUNT:COUNT) = CHAR(I)
      COUNT = COUNT+1
      I = (CRC0 / 16) + B2OFF
      BUFFR(COUNT:COUNT) = CHAR(I)
      COUNT = COUNT+1
      I = MOD(CRC0,16) + B2OFF
      BUFFR(COUNT:COUNT) = CHAR(I)
C
C  ADD END OF MESSAGE
C
      COUNT = COUNT+1
      BUFFR(COUNT:COUNT) = CHAR(EOM)
C
C  SEND THE DATA
C
      ERROR = .FALSE.
      IF (BUGFG) THEN
        WRITE (0,FMT=10000)
10000   FORMAT (1X,'XMIT --')
        IF (COUNT.LT.62) WRITE (0,FMT=10001) COUNT,BUFFR(1:COUNT)
        IF (COUNT.GT.61) WRITE (0,FMT=10001) COUNT,BUFFR(1:61),
     +   BUFFR(62:COUNT)
10001   FORMAT (1X,'COUNT=',I3,'  BUFFR=',A,/,1X,A)
        END IF
      CALL LNXMT (BUFFR,COUNT,ERROR,CNNCT)
      RETURN

      ENTRY STRCV

C********************************************************************
C
C  RECEIVE A BUFFER FROM THE LINE
C
C********************************************************************

C
C  READ THE DATA FROM THE LINE
C
      ERROR = .FALSE.
      RCHIB = .FALSE.
      RCNIB = .FALSE.
      RCCMP = 0
      RCIDX = 1
      CALL LNRCV(BUFFR,COUNT,CTMOT,ERROR,CNNCT)
      IF (BUGFG) THEN
        WRITE (0,FMT=10002) ERROR,CNNCT
10002   FORMAT (1X,'ERROR = ',L1,3X,'CONNECT = ',L1)
        IF (.NOT. ERROR) THEN
          IF (COUNT.LT.61) WRITE (0,FMT=10001) COUNT,BUFFR(1:COUNT)
          IF (COUNT.GT.60) WRITE (0,FMT=10001) COUNT,BUFFR(1:60),
     +     BUFFR(61:COUNT)
          END IF
        END IF
      IF (.NOT. ERROR) THEN
C
C  SETUP RECEIVE PARAMETERS
C
        RCVBF = BUFFR(4:COUNT)
        RCCNT = COUNT - 7
        RCTYP = ICHAR(BUFFR(1:1))
        RCXSQ = ICHAR(BUFFR(2:2)) - 48
        RCSEQ = ICHAR(BUFFR(3:3)) - 48
C
C  CHECK CRC
C
        CRC0 = 0
        CRC1 = 0
        COUNT = COUNT - 4
        DO 210 I = 1,COUNT
        CALL CALCC(ICHAR(BUFFR(I:I)))
210     CONTINUE
        CRC0H = CRC0 / 16 + B2OFF
        CRC0L = MOD(CRC0,16) + B2OFF
        CRC1H = CRC1 / 16 + B2OFF
        CRC1L = MOD(CRC1,16) + B2OFF
        I = COUNT + 1
        IF (CRC1H.NE.ICHAR(BUFFR(I:I))) GOTO 220
        I = I + 1
        IF (CRC1L.NE.ICHAR(BUFFR(I:I))) GOTO 220
        I = I + 1
        IF (CRC0H.NE.ICHAR(BUFFR(I:I))) GOTO 220
        I = I + 1
        IF (CRC0L.EQ.ICHAR(BUFFR(I:I))) GOTO 230
220     ERROR = .TRUE.
230     CONTINUE
        END IF

      RETURN
      END

C********************************************************************
C  END OF STXMTRCV.F77
C********************************************************************

